/* mnb1r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int mnb1r_c(integer *n, real *x, real *f, real *eps,
        integer *maxk, integer *mkat, integer *mcyc, real *alpha, real *beta,
        integer *nstep, real *epsy, real *x1, real *v, real *bl, real *al,
        real *d__, real *blen, real *aj, real *e, S_fp fun, integer *ierr)
{
    /* Initialized data */

    static real epsb = 1e-10f;

    /* System generated locals */
    integer v_dim1, v_offset, bl_dim1, bl_offset, al_dim1, al_offset, i__1, 
            i__2, i__3, i__4;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static real sumn, sumo;
    static integer i__, j, k;
    static real fbest, sumav;
    static integer ii, ji, jj, kk, kl, kk1;
    static real sumavv, dif;
    static integer iii, kat;

#define v_ref(a_1,a_2) v[(a_2)*v_dim1 + a_1]
#define al_ref(a_1,a_2) al[(a_2)*al_dim1 + a_1]
#define bl_ref(a_1,a_2) bl[(a_2)*bl_dim1 + a_1]


/* -------POPAMMA EYCOBHO MHMA */
/*     METOOM POEHPOKA */
/*           APAMETP */
/*     N     -PAMEPHOCT POCTPAHCTBA */
/*     X     -HA BXOE-HAAHA TOKA OCKA, */
/*           HA BX.-OCEH YAHA TOKA */
/*     F     -BCEHH MHMYM YHK */
/*     EPS   -(BXOHO) HAAH A O */
/*           OPTOOHAHM HAPABEHM */
/*     MAXK  -HA BXOE MAKCMAHOE, HA BXOE */
/*           BOHEHHOE CO BCEHE YHK */
/*     MKAT  -HA BXOE MAKCM., HA BXOE */
/*           BOHEHHOE CO TAOB */
/*     MCYC  -(BX.) MAKCMAHOE CO KOB */
/*           HA OHOM TAE METOA */
/*     ALPHA,BETA-(BX.) APAMETP METOA */
/*     NSTEP -PHAK OHOBEH H AA */
/*           (EC NSTEP.EQ.1, TO KA TA */
/*           HAHAETC C AA EPS) */
/*     EPSY  -AAHHA TOHOCT O YHKOHAY */
/*     IERR  -PHAK OKOHAH OCKA */
/*     FUN   -POPAMMA BCEH HAEH */
/*           EEBO YHK */
/*     OCTAHE APAMETP - PAOE MACCB */
/*     AOPTMA */
/* -------------------------------------------------- */

    /* Parameter adjustments */
    --e;
    --aj;
    --blen;
    --d__;
    al_dim1 = *n;
    al_offset = 1 + al_dim1 * 1;
    al -= al_offset;
    bl_dim1 = *n;
    bl_offset = 1 + bl_dim1 * 1;
    bl -= bl_offset;
    v_dim1 = *n;
    v_offset = 1 + v_dim1 * 1;
    v -= v_offset;
    --x1;
    --eps;
    --x;

    /* Function Body */
    kat = 1;
    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
        i__2 = *n;
        for (jj = 1; jj <= i__2; ++jj) {
            v_ref(ii, jj) = 0.f;
            if (ii == jj) {
                v_ref(ii, jj) = 1.f;
            }
/* L110: */
        }
    }
    (*fun)(&x[1], &sumo, epsy);
    i__2 = *n;
    for (k = 1; k <= i__2; ++k) {
/* L120: */
        x1[k] = x[k];
    }
    kk1 = 1;
    if (*nstep == 1) {
        goto L140;
    }
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
/* L130: */
        e[i__] = eps[i__];
    }

/* *****HAAO TAA. KK1-CETK TAOB */

L140:
    fbest = sumo;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
        aj[i__] = 2.f;
        if (*nstep != 1) {
            goto L150;
        }
        e[i__] = eps[i__];
L150:
        d__[i__] = 0.f;
    }
    iii = 0;

/* *****HAAO KA. III-CETK KOB */

L160:
    ++iii;
L170:
    i__ = 1;
L180:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L190: */
        x[j] += e[i__] * v_ref(i__, j);
    }

/* *****OPAEHE K SUBR. BCEH YHK. */

    (*fun)(&x[1], &sumn, epsy);
    ++kat;
/* L210: */
    if (kat - *maxk >= 0) {
        goto L220;
    } else {
        goto L230;
    }
L220:
    *ierr = 66;
    goto L430;
L230:
    if (sumn <= sumo) {
        goto L250;
    }
/* *****HEYAH A O HAPABEH E(I) */
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L240: */
        x[j] -= e[i__] * v_ref(i__, j);
    }
    e[i__] = -(*beta) * e[i__];
    if (aj[i__] < 1.5f) {
        aj[i__] = 0.f;
    }
    goto L270;
/* *****YAH A O HAPABEH E(I) */
L250:
    d__[i__] += e[i__];
    e[i__] = *alpha * e[i__];
    sumo = sumn;
    i__2 = *n;
    for (k = 1; k <= i__2; ++k) {
/* L260: */
        x1[k] = x[k];
    }
    if (aj[i__] > 1.5f) {
        aj[i__] = 1.f;
    }
L270:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        if (aj[j] > .5f) {
            goto L290;
        }
/* L280: */
    }
    goto L320;
L290:
    if (i__ == *n) {
        goto L300;
    }
    ++i__;
    goto L180;
L300:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        ji = aj[j] + .5f;
        if (ji == 1) {
            goto L170;
        }
/* L310: */
    }
/* *****AHA O KPTEP CA KOB */
    if (iii < *mcyc) {
        goto L160;
    }
/* *****EPECET OPTOOHAHX HAPABEH */
/*    METOOM PAMA-MTA */
L320:
    ++kk1;
    if (kk1 >= *mkat) {
        goto L425;
    }
    dif = fbest - sumo;
    if (dif > *epsy) {
        goto L325;
    }
    *ierr = 0;
    goto L430;
L325:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
/* L330: */
            al_ref(i__, j) = 0.f;
        }
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        kl = i__;
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            i__3 = *n;
            for (k = kl; k <= i__3; ++k) {
/* L340: */
                al_ref(i__, j) = d__[k] * v_ref(k, j) + al_ref(i__, j);
            }
/* L350: */
            bl_ref(i__, j) = al_ref(i__, j);
        }
    }
    blen[1] = 0.f;
    i__2 = *n;
    for (k = 1; k <= i__2; ++k) {
        blen[1] += bl_ref(1, k) * bl_ref(1, k);
/* L360: */
    }
    blen[1] = (real)sqrt(blen[1]);
    if (abs(blen[1]) <= epsb) {
        goto L375;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L370: */
        v_ref(1, j) = bl_ref(1, j) / blen[1];
    }
L375:
    i__2 = *n;
    for (i__ = 2; i__ <= i__2; ++i__) {
        ii = i__ - 1;
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            sumavv = 0.f;
            i__3 = ii;
            for (kk = 1; kk <= i__3; ++kk) {
                sumav = 0.f;
                i__4 = *n;
                for (k = 1; k <= i__4; ++k) {
/* L380: */
                    sumav += al_ref(i__, k) * v_ref(kk, k);
                }
/* L390: */
                sumavv = sumav * v_ref(kk, j) + sumavv;
            }
/* L400: */
            bl_ref(i__, j) = al_ref(i__, j) - sumavv;
        }
    }
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        blen[i__] = 0.f;
        i__2 = *n;
        for (k = 1; k <= i__2; ++k) {
/* L410: */
            blen[i__] += bl_ref(i__, k) * bl_ref(i__, k);
        }
        blen[i__] = (real)sqrt(blen[i__]);
        if ((r__1 = blen[i__], abs(r__1)) <= epsb) {
            goto L420;
        }
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
/* L415: */
            v_ref(i__, j) = bl_ref(i__, j) / blen[i__];
        }
L420:
        ;
    }
    goto L140;
/* ****BXO  OPOPAMM */
L425:
    *ierr = 68;
L430:
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L440: */
        x[i__] = x1[i__];
    }
    *mkat = kk1;
    *maxk = kat;
    *f = sumo;
    return 0;
} /* mnb1r_c */

#undef bl_ref
#undef al_ref
#undef v_ref
